=== modified file 'drizzled/module/loader.cc'
--- drizzled/module/loader.cc	2010-08-06 17:57:15 +0000
+++ drizzled/module/loader.cc	2010-08-12 17:36:08 +0000
@@ -472,7 +472,10 @@
       plugin_initialize_vars(module);
 
       if (plugin_initialize(registry, module))
+      {
+        registry.remove(module);
         delete_module(module);
+      }
     }
   }
 }

=== modified file 'drizzled/module/registry.cc'
--- drizzled/module/registry.cc	2010-05-15 18:23:34 +0000
+++ drizzled/module/registry.cc	2010-08-12 17:36:08 +0000
@@ -91,6 +91,14 @@
   module_map[add_str]= handle;
 }
 
+void module::Registry::remove(module::Module *handle)
+{
+  string remove_str(handle->getName());
+  transform(remove_str.begin(), remove_str.end(),
+            remove_str.begin(), ::tolower);
+
+  module_map.erase(remove_str);
+}
 
 vector<module::Module *> module::Registry::getList(bool active)
 {

=== modified file 'drizzled/module/registry.h'
--- drizzled/module/registry.h	2010-05-15 18:23:34 +0000
+++ drizzled/module/registry.h	2010-08-12 17:36:08 +0000
@@ -70,6 +70,7 @@
 
   void add(Module *module);
 
+  void remove(Module *module);
 
   std::vector<Module *> getList(bool active);
 

